<?php

/**
 * @file
 * provides the drag and drop interface for menu items.
 */

/**
 * Callback function for reorder tab.
 */
function submenu_reorder_node_page_reorder($form_state, $node) {

  // Finding mlid and plid of current node path.
  $menu_record = db_fetch_object(db_query("SELECT mlid, plid, menu_name FROM 
    {menu_links} WHERE link_path = '%s'", 'node/' . $node->nid));

  // Finding siblings.
  $menu_name = $menu_record->menu_name;

  $menu_all_siblings = db_query("SELECT mlid, plid, weight, link_title FROM 
    {menu_links} WHERE plid = %d ORDER BY weight ASC", $menu_record->plid);

  while ($row = db_fetch_object($menu_all_siblings)) {
    $data = array(
      check_plain($row->link_title),
    );

    $form['menu_items'][$row->mlid]['data'] = array(
      '#type' => 'value',
      '#value' => $data,
    );

    $form['menu_items'][$row->mlid]['weight-' . $row->mlid] = array(
      '#type' => 'textfield',
      '#size' => 5,
      '#default_value' => $weight,
      '#attributes' => array('class' => 'weight'),
    );
  }

  $form['menu_name'] = array(
    '#type' => 'hidden',
    '#value' => $menu_name,
  );
  $form['actions']['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save Changes'),
  );
  return $form;
}

/**
 * Returns HTML for a table.
 *
 * @param array $form
 *   An associative array containing:
 *   - form: An array of form fields for reorder menu items.
 */
function theme_submenu_reorder_node_page_reorder($form) {

  foreach ($form['menu_items'] as $id => $row) {
    if (intval($id)) {
      $this_row = $row['data']['#value'];
      $this_row[] = drupal_render($form['menu_items'][$id]['weight-' . $id]);
      $table_rows[] = array('data' => $this_row, 'class' => 'draggable');
    }
  }

  $header = array(
    t('Menu Items'), t('Weight'),
  );
  $output = theme('table', $header, $table_rows, array('id' => 'menu-items-reorder-table'));
  $output .= drupal_render($form);

  drupal_add_tabledrag('menu-items-reorder-table', 'order', 'sibling', 'weight');

  return $output;
}

/**
 * Implements hook_submit().
 */
function submenu_reorder_node_page_reorder_submit($form, &$form_state) {
  foreach ($form_state['values'] as $key => $data) {
    if (drupal_substr($key, 0, 6) == 'weight') {
      $id = str_replace('weight-', '', $key);
      db_query("UPDATE {menu_links} SET weight = %d WHERE mlid = %d", $data, $id);
    }
  }
  drupal_set_message(t('The menu items order has been successfully saved.'));
  menu_cache_clear_all();
}
